extends Control

@export var score_label: Label
@export var name_field: LineEdit

var highscore
var level_nr

func _ready():
	score_label.set_text(Globals.config.Username)

func _on_submit_button_pressed():
	var factory = RequestFactory.new($HTTPRequest, Globals.config.HighscoreServerAddr)
	var score = Score.new(name_field.text, {"level"+str(level_nr): highscore})
	factory.resolve_submit_request(func (result, response_code, h, body):
		if response_code == 200:
			var json = JSON.parse_string(body.get_string_from_utf8())
			print(json)
			var scores = load("res://src/gui/menu/scores.tscn").instantiate()
			scores.scores = json
			scores.level_nr = level_nr
			get_parent().add_child((scores))
		else:
			return # TODO: Show Dialog
	, score)

func _on_retry_button_pressed():
	get_tree().reload_current_scene()

func _on_next_button_pressed():
	var next_level = level_nr + 1
	if next_level > 12:
		next_level = 1
	load_level("res://src/game/levels/level_%s.tscn" % next_level)

func load_level(path: String):
	get_tree().change_scene_to_file(path)
