extends Control

@export var level_select: Control
@export var level_first_selection: Control
@export var leaderboard: Control
@export var scrollboard_vbox: Control
@export var scrollboard_item: Control

var scores
var level_nr

# Called when the node enters the scene tree for the first time.
func _ready():
	level_first_selection.grab_focus()
	scrollboard_item.hide()
	if level_nr != null:
		level_select.hide()
		load_level(level_nr)

func _on_quit_button_pressed():
	get_tree().quit()

func _on_back_button_pressed():
	level_select.hide()

func _on_level_button_pressed(level: int):
	load_level(level)

func load_level(level: int):
	leaderboard.show()
	load_leaderboard_content(level)

func load_leaderboard_content(level: int):
	var factory = RequestFactory.new($HTTPRequest, Globals.config.HighscoreServerAddr)
	factory.resolve_list_request(func (result, response_code, h, body):
		if response_code == 200:
			var json = JSON.parse_string(body.get_string_from_utf8())
			for k in json:
				var node = scrollboard_item.duplicate()
				var children = node.get_children()
				children[0].text = k + 1
				children[1].text = json[k].player
				children[2].text = str(json[k].score)
				scrollboard_vbox.add_child(node)
		else:
			return # TODO: Show dialog
	, "level" + str(level))
