class_name RequestFactory

const headers = [
	"Content-Type: application/json",
	"Authorization: Bearer " + Config.Secrets.ApiToken
]
const api_base_path = "/api/v2"
var base_uri: String
var node: HTTPRequest

func _init(node: HTTPRequest, base_uri: String):
	self.base_uri = base_uri + api_base_path
	self.node = node

func new_submit_request(score: Score) -> ApiRequest:
	score.valkey = score.valKey()
	var body = JSON.stringify(score)
	return ApiRequest.new(self.base_uri + "/score/submit/" + Config.ProjectName.to_lower(), self.headers, HTTPClient.METHOD_POST, body)

func new_list_request(key: String, offset: int = 0, limit: int = -1) -> ApiRequest:
	return ApiRequest.new(
		self.base_uri + "/score/list/" + Config.ProjectName.to_lower() + "?key=" + key + "&offset=" + str(offset) + "&limit=" + str(limit), 
		self.headers, HTTPClient.METHOD_GET)

func resolve_submit_request(f: Callable, score: Score):
	score.valkey = score.valKey()
	var body = JSON.stringify(score)
	self.node.request_completed.connect(f)
	self.node.request(self.base_uri + "/score/submit/" + Config.ProjectName.to_lower(), headers, HTTPClient.METHOD_GET, body)

func resolve_list_request(f: Callable, key: String, offset: int = 0, limit: int = -1):
	self.node.request_completed.connect(f)
	self.node.request(self.base_uri + "/score/list/" + Config.ProjectName.to_lower() + "?key=" + key + "&offset=" + str(offset) + "&limit=" + str(limit), headers, HTTPClient.METHOD_GET)
